/* code03e8.c - SysAppLaunch handler
   Copyright  1999 Mitch Blevins
   distributed under the GNU GPL.
   Based on LinkHistoryHack by Ben Darnell <dgdarnel@unity.ncsu.edu>
   Based on SampleHack by Roger Chaplin <foursquaredev@att.net>
*/

#include <Pilot.h>
#include <FeatureMgr.h>
#include <SysEvtPrv.h>
#include "findIgnoreHack.h"
#include "findIgnoreHackRsc.h"



// This is the code that will be called whenever ANY app calls EvtGetEvent,
// and myhack is enabled in HackMaster. HackMaster is not smart about the
// content of this file; it will simply jump to the first executable statement
// in this file. If you need helper functions, prototype them above, and
// define them AFTER the trap patch.
Err MySysAppLaunch(UInt cardNo, LocalID dbID, UInt launchFlags, Word cmd,
                    Ptr cmdPBP, DWord *resultP) {
   DWord temp;
   Err (*oldTrap)(UInt, LocalID, UInt, Word, Ptr, DWord*);
   Err err;
   MyPrefsType prefs;
   Word prefssize=sizeof(prefs);
   UInt i, curCardNo;
   LocalID curdbID;
   ULong creatorID, callbackCreator;

   // get the address of the old SysAppLaunch() from HackMaster
   FtrGet(MYCRID, 0x3e8, &temp);
   // set the function pointer to the old trap
   oldTrap = (Err (*)(UInt, LocalID, UInt, Word, Ptr, DWord*)) temp;

   if (cmd == sysAppLaunchCmdFind) {
       MemSet(&prefs, sizeof(MyPrefsType), 0);
       if ((PrefGetAppPreferences('FIHK', 0, &prefs, &prefssize, true)
                        ==noPreferenceFound)||(prefssize<sizeof(prefs))) {
            MemSet(&prefs, sizeof(MyPrefsType), 0);
       }
       err = 0;
       err = SysCurAppDatabase(&curCardNo, &curdbID);

       if (!err)
        err = DmDatabaseInfo(cardNo, dbID, NULL, NULL, NULL, NULL, NULL, NULL,
                       NULL, NULL, NULL, NULL, &creatorID);

       if ( !err && !((dbID==curdbID)&&(cardNo==curCardNo)) ) {
          for (i=0; i<64; i++) {
            if (!prefs.creatorID[i]) break;
            if (prefs.creatorID[i] == creatorID) {
                if (creatorID == sysFileCAddress) {
                    err = DmDatabaseInfo(((FindParamsPtr)cmdPBP)->appCardNo,
                                  ((FindParamsPtr)cmdPBP)->appDbID,
                                  NULL, NULL, NULL, NULL, NULL, NULL,
                                  NULL, NULL, NULL, NULL, &callbackCreator);
                    if (err || (callbackCreator != 'TlPh')) {
                        *resultP = 0;
                        return 0;
                    }
                }
                else {
                     *resultP = 0;
                     return 0;
                }
            }
          }
       }

   }
   return oldTrap(cardNo, dbID, launchFlags, cmd, cmdPBP, resultP);
}

